Issue 11901 - Selecting a paragraph and end of paragraph marker
Selecting a paragraph and end of paragraph marker
Status: ACCEPTED
Product: Writer
Classification: Application
Component: code
OOo 1.1
PC All
: P4 trivial with 7 votes (vote)
: ---
Assigned To: AOO issues mailing list
: oooqa
: 79495 97163 100475 100513 100921 109348 113500 (view as issue list)
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2003-02-28 04:24 UTC by lamarcbr
Modified: 2013-08-07 14:38 UTC (History)
4 users (show)

See Also:
Issue Type: ENHANCEMENT
Latest Confirmation on: ---
Developer Difficulty: ---


Attachments
Document for demonstrating listed issues (13.21 KB, application/vnd.sun.xml.writer)
2004-02-23 18:08 UTC, jbotte
no flags Details
Skinned calc dialog box (Format Cell). (36.30 KB, image/jpeg)
2004-09-13 16:29 UTC, lamarcbr
no flags Details
Select Paragraph as in Wordpad (14.32 KB, image/png)
2007-05-18 07:27 UTC, pesala
no flags Details

Note You need to log in before you can comment on or make changes to this issue.
Description lamarcbr 2003-02-28 04:24:45 UTC
I believe there's a problem with selecting, moving and copying paragraphs with
OO Write.

I am consistently unable to select a paragraph with the mouse. The text within
the paragraph is selected, but the paragraph mark (i.e. delimiter), designated
as [P] in this request, stays put. Here's a sample paragraph:

Hello, my Name is John[P]
[P]
[P]
[P]
[P]
We have a full moon[P]
[P]

If I move the paragraph {we have a full moon} using the CTRL+UP/DOWN it moves
properly. For instance, if I move it to the top of the page, it will place the
{we have a full moon} paragraph above the {Hello, my Name is John} paragraph. So
this is the result:

We have a full moon[P]
Hello, my Name is John[P]
[P]
[P]
[P]
[P]
[P]

However, if I select the text with the mouse, I am unable to select the
paragraph, but only the text within the paragraph. Selecting {We have a full
moon} using the mouse, then dragging the "selected" paragraph to the top of the
page gives me this result:

We have a full moonHello, my Name is John[P]
[P]
[P]
[P]
[P]
[P] <- hey, why is this still here? I thought I selected the paragraph!
[P]

There does not seem to be a consistent way to select the paragraph marker.

There's a Select Paragraph command, which I've put on the toolbar, and it does
not alter this behavior. It only selects the text in the paragraph, not the
paragraph itself, To move the paragraph, the user must be able to move the
paragraph marker, without having to select below, above, to the left or right of
the paragraph. As stated in the Help File, under paragraph marks: "The paragraph
delimiters also contain paragraph format information."

I've checked all the newsgroups and issues postings and no one has reported this.

This makes the product difficult to use.
Comment 1 eric.savary 2003-04-24 02:39:06 UTC
Select the previous/next empty paragraph to include the paragraph 
mark.
That's how every text editors/word processor work.
Comment 2 eric.savary 2003-04-24 02:39:28 UTC
closed
Comment 3 lamarcbr 2003-05-09 04:01:54 UTC
I'm re-opening this issue because the reasons for closing this issue 
are inconsistent with the feature set of OO Write.

This issue merely attempts to reproduce, using the mouse, what can be 
done using the keyboard, via dragging and dropping withing the 
Navigator, or the "move paragraph" buttons wich can be added to the 
toolbar.

Furthermore, this is not how "every word processor works." It is 
however, how every text editor works, but when using a word 
processor, one would expect to be able to select and move all object 
with the mouse. The paragraph is an object. It cannot be moved or 
copied using the mouse. Only the text inside the paragraph can be 
moved.

I respectfully request that you give this posting thorough 
consideration.
Comment 4 prgmgr 2003-06-16 00:48:58 UTC
Benoit, thank you for using and supporting OOo.

The trick is to move the mouse down one line after selecting the
paragraph so that the paragraph marker is selected as well.

I'm marking this as an enhancement request.


Summary

The user would like the operation of selecting a paragraph to be either:

1.  Visually consistent with the keyboard paragraph move behaviour.
2.  Better process and confirmation for selecting the end of
    paragraph marker.


When using the keyboard to select and move paragraph text, there is no
visual confirmation that the end of paragraph marker is selected.

  Some Text[p]  [p] is not highlighted

Yet when you use the Ctrl-Up Arrow ( other move commands ) to move the
text, the entire block ( Some Text[p] ) is moved.

When using a mouse, the user has to explictly select the end of
paragraph marker by first moving to the end of the paragraph and
dropping the mouse down one line.

For comparision, MS Word will select the end of paragraph marker when
the user moves the mouse to the end of the line.  The same behaviour
happens using the keyboard.



User summary
Unable to select paragraph using the mouse.
Comment 5 prgmgr 2003-06-16 00:49:27 UTC
Reassigning to the feature area.
Comment 6 lamarcbr 2003-06-17 04:27:27 UTC
Thank you for making excellent software, looking at this issue, and
suggesting a work around. Please note that this work around will not
work on the last paragraph of a document.

As noted, Word behaves differently. It is my experience with Microsoft
Word that prompted to post this notice.

Issues 10969, 10970, and 10971 are somewhat related to the issue you
are reading. There's some duplication there, and some innacuracies,
but I think you'll get the idea.
Comment 7 bettina.haberer 2003-10-24 09:24:13 UTC
Thank you for reporting this issue. This issue is considered for
'Office later'.
Comment 8 jbotte 2004-02-23 18:05:18 UTC
I am going to have to agree with lamarcbr on this one... I was going to report
this as an Enhancement request myself.

Every word processing program I have ever used allows you select the end of
paragraph marker as part of the selection with the mouse. Not being able to do
this has several effects:

1. If you have to move down into the next paragraph to select the end of the
paragraph as was suggested, you get the formatting from the next paragraph as
part of your selection. For instance, if the next paragraph has a paragraph
number, you get the paragraph number as well. Either way, the context you end up
with if you want to keep typing is the style of the paragraph *after* the one
you wanted to copy, not the one you copied.

2. If you do not move the to start of the next paragraph (with all the problems
given in 1., above), you have an empty paragraph that you have to clean up where
you cut the text... again, it not what would be expected.

3. Furthermore, given the copy or cut as given in 2., if you paste the text at
the start of a new paragraph, you merge the two paragraphs together rather than
displacing the paragraph that starts at the insertion point and you now have a
mixed-style paragraph. You then need to separate the paragraphs by pressing
Enter... again, not what I would have expected based on my experience.

4. And, as lamarcbr states, it is impossible to delete the last paragraph in a
document (if you go to the previous paragraph and press Delete, the style of the
last paragraph is now applied to the end of the paragraph you were in when you
pressed Delete, and again, you're stuck with the end format), or change the
format of the last paragraph in a document using a style (it does not seem to
reset the style of the end of the last paragraph because you have not selected
it). To fix the problem, you have to go to the bar at the top and select the
font, size, and format that you want. It breaks the paragraph styles paradigm.

For these useability/design/philosophic reasons, and the fact that this works
differently than any word processing software that I have used previously, I
would like to see this Enhancement targetted for a release rather than left as
an open ended thing.
Comment 9 jbotte 2004-02-23 18:08:52 UTC
Created attachment 13364 [details]
Document for demonstrating listed issues
Comment 10 lamarcbr 2004-02-25 21:10:30 UTC
jbotte@openoffice.org : Many thanks for adding your own comments to this issue. 

While many of the fixes and enhancements published lately in the 680_mxx 
revisions appear to be on the back-end of the suite, I think the user 
interaction part needs to be addressed also. This type of fix also has to be 
simpler than developping a new database front-end (which I can't wait to see!).

One way to speed this up changes to paragraph handling is that perhaps you can 
vote for this issue. I'll see if I can post a note on one of the listserv to 
garner support (and more votes).

I've been signed with the ui project, although I'm not sure what I can do to 
help.

prgmgr and bh: I hope this is an acceptable practice.

The developpers are doing a great job of delivering an outstanding product. 
Their work is appreciated.

Comment 11 g.marxen 2004-03-29 17:03:02 UTC
I support this issue very much and think, that the developer do not understand
the case correctly. It is not a question of marking or moving with the mouse or
keyboard but a question of "transporting" all paragraph attributes (styles) with
the copied or cut text. 

One example: with text "Paragraph x formatted with ..." ([n.] is a paragraph end
mark; if you want to test, show all control characters in writer.

Paragraph 1 formatted with Heading 1 [n1]
Paragraph 2 formatted with Standard  [n2]
Paragraph 3 formatted with Haeding 2 [n3]
Paragraph 4 formatted with Standard  [n4]
Paragraph 5 formatted with Heading 3 [n5]

If you cut paragraph 2 and want to paste it after paragraph 4, the paragraph
attributes (style) are not transported correctly.  
You can mark the text only without the paragraph mark [n.] with mouse or keyboard:

Paragraph 2 formatted with Standard

or you mark the text and the end mark [n.] - the "cursor" is already in
Paragraph 3: 

Paragraph 2 Standard [n2]
| Paragraph 3                  (Cursor: | )

In the first case, there remains an empty paragraph, which must be deleted. And
after paragraph 4 must be inserted a new paragraph to avoid, that the style of
the inserted text is altered. 
In the second case, paragraph 3 looses its style "Heading 2". 

(Almost the same happens, if you delete a paragraph mark forward or backward.)

Wanted is, that one can mark and cut the paragraph with all attributes and with
the end mark so that it can be inserted with all this directly before the first
charachter of another paragraph without disturbing his own and the other
attributes. G. Marxen 
Comment 12 bettina.haberer 2004-04-08 21:53:50 UTC
Hello Andreas, do you agree with OOo later? 
Comment 13 lamarcbr 2004-04-11 19:45:12 UTC
Not that you've asked my opinion, but I certainly do not agree. I've already 
got one reply when I sent this to users@openoffice.org. To have a database in 
OO 2.0, great! But what about focusing on basic editing capabilities? Plus, 
wouldn't this be a simple enhancement, compared to all the other ones planned?

I don't get it.
Comment 14 lamarcbr 2004-09-13 16:29:14 UTC
Created attachment 17675 [details]
Skinned calc dialog box (Format Cell).
Comment 15 andreas.martens 2004-09-15 16:42:54 UTC
I've read the comment of a0071 and his analysis of the situation is absolute
correct except "the developers do not understand the case correctly" ;-)
You could select the complete paragraph including its paragraph mark with the
mouse if there is a paragraph behind your selection. This paragraph will inherit
the paragraph style of the moved paragraph. These both disadvantages has to be
changed but this will not be happen for OOo2.0.
I agree not to close this issue and with the target OOo Later.
BTW: the reason for the style problem is our algorithmn of merging paragraphs by
deleting the paragraph mark (<DELETE> vs. <BACKSPACE>).
Comment 16 ianfordx 2005-12-23 18:30:25 UTC
There is a design flaw with most word processors, that stands out in OOo, but is
also annoying in Word. That is, moving text can have unintended consequences
with paragraph formats. For example, if you delete a bulleted paragraph above a
heading, the heading could become bulleted.

I have developed a solution that addresses the concerns raised in:

11901: Selecting a paragraph and end of paragraph marker (long)
19547: Selecting text WITH last paragraph sign would be easyer
50280: quadruple-click to select paragraph should also select return character
8312: Tripple-click should select entire paragraph
32804: RFE for easier paragraph selection with the mouse


First, there should be no such concept as a paragraph marker. It may be a valid
programmer concept, but should not play a role in the UI.

Selection should be limited to one of the following:

TYPE A: Any number of characters within ONE paragraph, including all characters.
The selection does not include paragraph styles/formats. If the selection is cut
or deleted, there is no change in the paragraph format. If the selection is
pasted, the target paragraph format does not change. If the selection is all
characters in a paragraph, and the selection is deleted, there is an empty
paragraph remaining.

TYPE B: Any number of whole paragraphs. The selection includes all paragraph
formats/styles. If the selection is cut or deleted, the entire paragraph(s) are
deleted. If the selection is pasted after the last character of a paragraph, or
before the first character of a paragraph, then the pasted paragraph(s) are
inserted between the two existing ones. if the selection is pasted after the
last character in a document, the last paragraph is unchanged and the selection
is added to the document as paragraphs. If the selection is pasted before the
first character of a document, the first paragraph is unchanged, the and the
selection is inserted at the beginning of the document as paragraphs. If the
selection is pasted within a paragraph, the target paragraph is first split into
two at that point, then the selection is inserted as whole paragraphs between
the two target paragraphs.

TYPE C: Some characters in a top paragraph, all characters in zero or more
middle paragraphs, and some characters in a bottom paragraph, with certain
restrictions. The restrictions are that all paragraphs have identical formats,
and that either (a) the first character of the top paragraph  is not included,
or (b) the last character of the bottom paragraph is not included. The 
paragraph formats are NOT included with the selection. Instead the selection is
treated as type A with embedded paragraph breaks. If the selection is cut or
deleted, the top and bottom paragraphs are joined (as they must have the same
format). If the selection is pasted, the target paragraph is divided into 2 or
more paragraphs that have the same format.

The visual indicators of types A, B, and C are as follows: Type A and C are
indicated by a highlight that looks like OOo 2.0. Type B is indicated by a
highlight that extends left and right to the edge of the page or window. So, if
the highlight is wide, it includes paragraph formatting; otherwise it only
includes character formatting.

The keyboard and mouse selection rules would be:

(1)	If you have a type A selection that includes all characters in a paragraph,
and then you press the right arrow key (if you are at the end of the paragraph)
or the left arrow key (if you are at the top of the paragraph), the selection
changes to type B, and the whole paragraph is selected.

(2)	If you have a type A selection that includes all characters in a paragraph,
and you use any means to extend the selection into another paragraph, then the
selection changes to type B, and both paragraphs are selected.

(3)	If you have a type B selection, and you extend the selection by as little as
one character, it remains type B, and whole paragraphs are added to the
selection. So you can hold Shift and press the right arrow to select additional
paragraphs.

(4)	If you have a type A selection that does NOT include all characters in the
paragraph, and you extend the selection by any means into another paragraph,
then it either becomes a type B or C selection depending on the format. If the
formats are identical, it becomes a type C
selection; otherwise it becomes type B.

(5)	If you have a type C selection, and you extend the selection by any means
into another paragraph that does not have an identical format, then it becomes
type B.

The user will have to do certain things differently with this design. For
example, to move part of one paragraph and all of the next one, if the formats
are different, the user must FIRST break the first paragraph into two, then move
two complete paragraphs. This guarantees that the formats of any other
paragraphs are not affected. If the user does not break the first paragraph into
two, then there will no way to make that selection. And there shouldn’t be,
because it is an undefined selection.
Comment 17 andreas.martens 2007-02-21 13:06:44 UTC
->ianfordx
Thank you for your valuable input.It's a very interesting concept and I have to
think about it. I like the "select complete paragraph" mode.
Comment 18 pesala 2007-05-18 07:27:39 UTC
Created attachment 45212 [details]
Select Paragraph as in Wordpad
Comment 19 pesala 2007-05-18 07:31:47 UTC
Please implement paragraph selection as in Wordpad.

Double-click in the margin to select the entire paragraph including the paragraph 
marker. Shift-click to extend the selection. Control click to select all (entire 
document). Single-click to select a line (nearest sentence might be more useful).

Already familiar to many users, intuitive, and easy to use. (Quadruple click is 
difficult and quickly tiring if used repeatedly).
Comment 20 eric.savary 2007-08-14 18:36:38 UTC
*** Issue 79495 has been marked as a duplicate of this issue. ***
Comment 21 michael.ruess 2009-03-24 14:07:17 UTC
*** Issue 100513 has been marked as a duplicate of this issue. ***
Comment 22 eric.savary 2009-03-24 14:14:06 UTC
*** Issue 100475 has been marked as a duplicate of this issue. ***
Comment 23 eric.savary 2009-04-07 15:34:35 UTC
*** Issue 100921 has been marked as a duplicate of this issue. ***
Comment 24 michael.ruess 2010-02-17 08:22:39 UTC
*** Issue 109348 has been marked as a duplicate of this issue. ***
Comment 25 michael.ruess 2010-02-17 09:23:04 UTC
*** Issue 97163 has been marked as a duplicate of this issue. ***
Comment 26 eric.savary 2010-07-28 22:33:08 UTC
*** Issue 113500 has been marked as a duplicate of this issue. ***
Comment 27 herrdeh 2010-07-29 09:42:01 UTC
I'm not sure whether my issue is covered by the contributions above, but to be sure to have mentioned 
it in the right place I paste it here again:

Using the keyboard shortcut "WordRightSel" selects the word right PLUS one whitespace (space, tab, line 
break right of the word.

"WordLeftSel" just selects one word without a whitespace - and for my feeling this is the correct 
behaviour - select just the letters of the word - and nothing more.